"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mcproto_1 = require("mcproto");
const defaultOptions = {
    checkPing: true,
    timeout: 10000
};
exports.getStatus = (options) => __awaiter(void 0, void 0, void 0, function* () {
    options = Object.assign(Object.assign({}, defaultOptions), options);
    const client = yield mcproto_1.Client.connect(options.host, options.port, {
        connectTimeout: options.timeout,
        timeout: options.timeout
    });
    client.send(new mcproto_1.PacketWriter(0x0).writeVarInt(498)
        .writeString(options.host).writeUInt16(client.socket.remotePort)
        .writeVarInt(mcproto_1.State.Status));
    client.send(new mcproto_1.PacketWriter(0x0));
    const status = (yield client.nextPacket()).readJSON();
    if (options.checkPing) {
        client.send(new mcproto_1.PacketWriter(0x1).write(Buffer.alloc(8)));
        const start = Date.now();
        yield client.nextPacket(0x1);
        status.ping = Date.now() - start;
    }
    client.end();
    return status;
});
